<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/29/2008 *
 * ================                             Last change: 09/29/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-refback.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Refback and ref overview                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ref-Back und Ref-Uebersicht                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Version number
setThisExtensionVersion('0.0.1');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0','0.0.1'));

switch (getExtensionMode())
{
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// SQL commands to run
		addExtensionSql("DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_refs`");
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_user_refs` (
`id` BIGINT(20) UNSIGNED NOT NULL auto_increment,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`level` smallINT(6) UNSIGNED NOT NULL DEFAULT 0,
`refid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`refback` float(4,1) NOT NULL DEFAULT 0.0,
`points` FLOAT( 20,5) DEFAULT 0.00000 NOT NULL,
PRIMARY KEY (`id`),
UNIQUE `user_refid` (`userid`,`level`,`refid`),
KEY (`level`),
KEY (`refid`)
) ENGINE={?_TABLE_TYPE?} COMMENT='User Referals With Refback'");
		addMemberMenuSql('main','refback','Ref-Back einstellen','N','Y',4);

		// Execute this special file on registration
		addIncludeToPool('extension', 'inc/gen_refback.php');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql("DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_refs`");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='refback'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE what IN('config_refback','list_refback')");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_refsystem` SET level=level-1");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='refback' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N', `locked`='Y' WHERE `what`='refback' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `refback_enabled` ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `refback_min_perc` TINYINT(3) NOT NULL DEFAULT 0");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `refback_max_perc` TINYINT(3) NOT NULL DEFAULT 100");
				addAdminMenuSql('setup','config_refback','Refback','&Auml;ndern Sie Einstellungen zum Refback, wie z.B. Minium- und Maximum-Prozente, was die Mitglieder einstellen d&uuml;rfen.',15);
				addAdminMenuSql('user','list_refback','Refback auflisten','Refback aller Mitglieder auflisten.',15);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Refback-System ist nun ein-/ausschaltbar und minimale/maximale Refback-Prozente sind festlegbar.");
				break;
		}
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown extension mode %s detected.", getExtensionMode()));
		break;
}

// [EOF]
?>
